unit OggVorbisDecoder;

interface

uses
	OggVorbisFileHeader, Classes;


	procedure SetOVCallbackForStream( const oc: POVCallbacks );

implementation

procedure SetOVCallbackForStream( const oc: POVCallbacks );
	function Stream_OVCallbackRead( const Dest: Pointer; const Size, nMemBlocks: Cardinal; const Source: Pointer ): Cardinal;
	var
		s: TStream absolute Source;
		l, d: Longint;
	begin
		if nMemBlocks = 0 then begin
			Result := 0;
			Exit;
		end;
		l := s.Read( Dest^, nMemBlocks*Size );
		d := l mod Integer(nMemBlocks);
		s.Seek( -d, soCurrent ); 
		Result := l-d;
	end;
	function Stream_OVCallbackSeek( const Source: Pointer; const Offset: Int64; const Whence: Integer ): Integer;
	const
		//gĂȂ
		SEEK_SET = 0;
		SEEK_CUR = 1;
		SEEK_END = 2;
	var
		s: TStream absolute Source;
	begin
		if ( Whence < 0 )or( 2 > Whence ) then begin
			Result := -1;
			Exit;
		end;
		try
			Result := s.Seek( Offset, TSeekOrigin( Whence ) );
		except
			Result := -1;
		end;
	end;
	function Stream_OVCallbackClose( const Source: Pointer ): Integer;
	var
		s: TStream absolute Source;
	begin
		try
			s.Free;
			Result := 0;
		except
			Result := -1;
		end;
	end;
	function Stream_OVCallbackTell( const Source: Pointer ): Longint;
	var
		s: TStream absolute Source;
	begin
		try
			Result := s.Position;
		except
			Result := -1;
		end;
	end;
begin
	oc.ReadFunc := @Stream_OVCallbackRead;
	oc.SeekFunc := @Stream_OVCallbackSeek;
	oc.CloseFunc := @Stream_OVCallbackClose;
	oc.TellFunc := @Stream_OVCallbackTell;
end;

end.
