unit OggVorbisHeader;

interface

uses
	Windows, SysUtils;

{$A8}

type
	PSingleArray = ^TSingleArray;
	TSingleArray = array[0..500000000] of Single;
	PPSingleArrayArray = ^TPSingleArrayArray;
	TPSingleArrayArray = array[0..500000000] of PSingleArray;
	PPChar = ^PChar;

	PVorbisInfo = ^TVorbisInfo;
	TVorbisInfo = record
		Version: Integer;
		Channels: Integer;
		Rate: Longint;

		BitrateUpper: Longint;
		BitrateNominal: Longint;
		BitrateLower: Longint;
		BitrateWindow: Longint;

		CodecSetup: Pointer;
	end;

	PVorbisDSPState = ^TVorbisDSPState;
	TVorbisDSPState = record
		Analysisp: Integer;
		vi: PVorbisInfo;

		PCM: PPSingleArrayArray;
		PCMRet: PPSingleArrayArray;

		PCMStorage: Integer;
		PCMCurrent: Integer;
		PCMReturned: Integer;

		PreExtraPolate: Integer;
		EOFFlag: Integer;

		lW: Longint;
		W: Longint;
		nW: Longint;
		centerW: Longint;

		GranulePos: Int64;
		Sequence: Int64;

		GlueBits: Int64;
		TimeBits: Int64;
		FloorBits: Int64;
		ResBits: Int64;

		BackendState: Pointer;
	end;

	POggPackBuffer = ^TOggPackBuffer;
	TOggPackBuffer = record
		EndByte: Longint;
		EndBit: Integer;

		Buffer: PByte;
		Ptr: PByte;
		Storage: Longint;
	end;

	PAllocChain = ^TAllocChain;
	TAllocChain = record
		ptr: Pointer;
		Next: PAllocChain;
	end;

	PVorbisBlock = ^TVorbisBlock;
	TVorbisBlock = record
		PCM: PPSingleArrayArray;
		opb: TOggPackBuffer;

		lW: Longint;
		W: Longint;
		nW: Longint;
		PCMEnd: Integer;
		Mode: Integer;

		EOFFlag: Integer;
		GranulePos: Int64;
		Sequence: Int64;

		vd: PVorbisDSPState;

		LocalStore: Pointer;
		LocalTop: Longint;
		LocalAlloc: Longint;
		TotalUse: Longint;
		Reap: PAllocChain;

		GlueBits: Longint;
		TimeBits: Longint;
		FloorBits: Longint;
		ResBits: Longint;

		Internal: Pointer;
	end;

	PVorbisComment = ^TVorbisComment;
	TVorbisComment = record
		UserComments: PPChar;
		CommentLengths: Integer;
		Comments: Integer;
		Vendor: PChar;
	end;

	POggPacket = ^TOggPacket;
	TOggPacket = record
		Packet: PByte;
		Bytes: Longint;
		B_O_S: Longint;
		E_O_S: LongInt;
		GranulePos: Int64;
		PacketNo: Int64;
	end;

	POggStreamState = ^TOggStreamState;
	TOggStreamState = record
		BodyData: PByte;
		BodyStorage: Longint;
		BodyFill: Longint;
		BodyReturned: Longint;

		LacingVals: PInteger;
		GranuleVals: PInt64;
		LacingStorage: Longint;
		LacingFill: Longint;
		LacingPacket: Longint;
		LacingReturned: Longint;

		Header: array[0..281] of Byte;
		HeaderFill: Integer;

		E_O_S: Integer;
		B_O_S: Integer;

		SerialNo: Longint;
		PageNo: Longint;
		PacketNo: Int64;
		GranulePos: Int64;
	end;

	POggPage = ^TOggPage;
	TOggPage = record
		Header: PByte;
		HeaderLen: Longint;
		Body: PByte;
		BodyLen: Longint;
	end;

	TOVEF_vorbis_encode_init_vbr_func =
		function ( const vi: PVorbisInfo; const Channels: Longint; const Rate: Longint; const BaseQuality: Single ): Integer; cdecl;

	TOVEF_vorbis_info_init_func =
		procedure ( const vi: PVorbisInfo ); cdecl;

	TOVEF_vorbis_info_clear_func =
		procedure ( const vi: PVorbisInfo ); cdecl;

	TOVEF_vorbis_dsp_clear_func =
		procedure ( const v: PVorbisDSPState ); cdecl;

	TOVEF_vorbis_block_init_func =
		function ( const v: PVorbisDSPState; const vb: PVorbisBlock ): Integer; cdecl;

	TOVEF_vorbis_block_clear_func =
		function ( const vb: PVorbisBlock ): Integer; cdecl;

	TOVEF_vorbis_comment_init_func =
		procedure ( const vc: PVorbisComment ); cdecl;

	TOVEF_vorbis_comment_add_func =
		procedure ( const vc: PVorbisComment; const Comment: PChar ); cdecl;

	TOVEF_vorbis_comment_add_tag_func =
		procedure ( const vc: PVorbisComment; const Tag, Contents: PChar ); cdecl;

	TOVEF_vorbis_comment_clear_func =
		procedure ( const vc: PVorbisComment ); cdecl;

	TOVEF_vorbis_analysis_init_func =
		function ( const v: PVorbisDSPState; const vi: PVorbisInfo ): Integer; cdecl;

	TOVEF_vorbis_analysis_func =
		function ( const vb: PVorbisBlock; const op: POggPacket ): Integer; cdecl;

	TOVEF_vorbis_analysis_headerout_func =
		function ( const v: PVorbisDSPState; const vc: PVorbisComment; const op: POggPacket; const op_comm: POggPacket; const op_code: POggPacket ): Integer; cdecl;

	TOVEF_vorbis_analysis_buffer_func =
		function ( const v: PVorbisDSPState; const vals: Integer ): PPSingleArrayArray; cdecl;

	TOVEF_vorbis_analysis_wrote_func =
		function ( const v: PVorbisDSPState; const vals: Integer ): Integer; cdecl;

	TOVEF_vorbis_analysis_blockout_func =
		function ( const v: PVorbisDSPState; const vb: PVorbisBlock ): Integer; cdecl;

	TOVEF_vorbis_synthesis_headerin_func =
		function ( const vi: PVorbisInfo; const vc: PVorbisComment; const op: POggPacket ): Integer; cdecl;

	TOVEF_vorbis_bitrate_addblock_func =
		function ( const vb: PVorbisBlock ): Integer; cdecl;

	TOVEF_vorbis_bitrate_flushpacket_func =
		function ( const v: PVorbisDSPState; const op: POggPacket ): Integer; cdecl;

	TOVEF_ogg_stream_init_func =
		function ( const os: POggStreamState; const serialno: Integer ): Integer; cdecl;

	TOVEF_ogg_stream_packetin_func =
		function ( const os: POggStreamState; const op: POggPacket ): Integer; cdecl;

	TOVEF_ogg_stream_flush_func =
		function ( const os: POggStreamState; const og: POggPage ): Integer; cdecl;

	TOVEF_ogg_stream_pageout_func =
		function ( const os: POggStreamState; const og: POggPage ): Integer; cdecl;

	TOVEF_ogg_page_eos_func =
		function ( const og: POggPage ): Integer; cdecl;

	TOVEF_ogg_stream_clear_func =
		function ( const os: POggStreamState ): Integer; cdecl;

	TOggVorbisEncodeFunctions = class
	private
		FOGGDLLHandle, FVORBISDLLHandle, FVORBISENCDLLHandle: THandle;
		Fvorbis_encode_init_vbr: TOVEF_vorbis_encode_init_vbr_func;
		Fvorbis_info_init: TOVEF_vorbis_info_init_func;
		Fvorbis_info_clear: TOVEF_vorbis_info_clear_func;
		Fvorbis_dsp_clear: TOVEF_vorbis_dsp_clear_func;
		Fvorbis_block_init: TOVEF_vorbis_block_init_func;
		Fvorbis_block_clear: TOVEF_vorbis_block_clear_func;
		Fvorbis_comment_init: TOVEF_vorbis_comment_init_func;
		Fvorbis_comment_add: TOVEF_vorbis_comment_add_func;
		Fvorbis_comment_add_tag: TOVEF_vorbis_comment_add_tag_func;
		Fvorbis_comment_clear: TOVEF_vorbis_comment_clear_func;
		Fvorbis_analysis_init: TOVEF_vorbis_analysis_init_func;
		Fvorbis_analysis: TOVEF_vorbis_analysis_func;
		Fvorbis_analysis_headerout: TOVEF_vorbis_analysis_headerout_func;
		Fvorbis_analysis_buffer: TOVEF_vorbis_analysis_buffer_func;
		Fvorbis_analysis_wrote: TOVEF_vorbis_analysis_wrote_func;
		Fvorbis_analysis_blockout: TOVEF_vorbis_analysis_blockout_func;
		Fvorbis_synthesis_headerin: TOVEF_vorbis_synthesis_headerin_func;
		Fvorbis_bitrate_addblock: TOVEF_vorbis_bitrate_addblock_func;
		Fvorbis_bitrate_flushpacket: TOVEF_vorbis_bitrate_flushpacket_func;
		Fogg_stream_init: TOVEF_ogg_stream_init_func;
		Fogg_stream_packetin: TOVEF_ogg_stream_packetin_func;
		Fogg_stream_flush: TOVEF_ogg_stream_flush_func;
		Fogg_stream_pageout: TOVEF_ogg_stream_pageout_func;
		Fogg_page_eos: TOVEF_ogg_page_eos_func;
		Fogg_stream_clear: TOVEF_ogg_stream_clear_func;
	protected
		procedure CallFuncBefore();
		procedure CallFuncAfter();
	public
		constructor Create();
		destructor Destroy(); override;
		function vorbis_encode_init_vbr( const vi: PVorbisInfo; const Channels: Longint; const Rate: Longint; const BaseQuality: Single ): Integer;
		procedure vorbis_info_init( const vi: PVorbisInfo );
		procedure vorbis_info_clear( const vi: PVorbisInfo );
		procedure vorbis_dsp_clear( const v: PVorbisDSPState );
		function vorbis_block_init( const v: PVorbisDSPState; const vb: PVorbisBlock ): Integer;
		function vorbis_block_clear( const vb: PVorbisBlock ): Integer;
		procedure vorbis_comment_init( const vc: PVorbisComment );
		procedure vorbis_comment_add( const vc: PVorbisComment; const Comment: PChar );
		procedure vorbis_comment_add_tag( const vc: PVorbisComment; const Tag, Contents: PChar );
		procedure vorbis_comment_clear( const vc: PVorbisComment );
		function vorbis_analysis_init( const v: PVorbisDSPState; const vi: PVorbisInfo ): Integer;
		function vorbis_analysis( const vb: PVorbisBlock; const op: POggPacket ): Integer;
		function vorbis_analysis_headerout( const v: PVorbisDSPState; const vc: PVorbisComment; const op: POggPacket; const op_comm: POggPacket; const op_code: POggPacket ): Integer;
		function vorbis_analysis_buffer( const v: PVorbisDSPState; const vals: Integer ): PPSingleArrayArray;
		function vorbis_analysis_wrote( const v: PVorbisDSPState; const vals: Integer ): Integer;
		function vorbis_analysis_blockout( const v: PVorbisDSPState; const vb: PVorbisBlock ): Integer;
		function vorbis_synthesis_headerin( const vi: PVorbisInfo; const vc: PVorbisComment; const op: POggPacket ): Integer;
		function vorbis_bitrate_addblock( const vb: PVorbisBlock ): Integer;
		function vorbis_bitrate_flushpacket( const v: PVorbisDSPState; const op: POggPacket ): Integer;
		function ogg_stream_init( const os: POggStreamState; const serialno: Integer ): Integer;
		function ogg_stream_packetin( const os: POggStreamState; const op: POggPacket ): Integer;
		function ogg_stream_flush( const os: POggStreamState; const og: POggPage ): Integer;
		function ogg_stream_pageout( const os: POggStreamState; const og: POggPage ): Integer;
		function ogg_page_eos( const og: POggPage ): Integer;
		function ogg_stream_clear( const os: POggStreamState ): Integer;
	end;

implementation

const
{$IFDEF USE_LIBVORBISDLL}
	OGG_DLL_NAME = 'libvorbis.dll';
	VORBIS_DLL_NAME = 'libvorbis.dll';
	VORBISENC_DLL_NAME = 'libvorbis.dll';
{$ELSE}
	OGG_DLL_NAME = 'ogg.dll';
	VORBIS_DLL_NAME = 'vorbis.dll';
	VORBISENC_DLL_NAME = 'vorbisenc.dll';
{$ENDIF}

{ TOggVorbisEncodeFunctions }

procedure TOggVorbisEncodeFunctions.CallFuncAfter;
begin
	Set8087CW(Default8087CW);
end;

procedure TOggVorbisEncodeFunctions.CallFuncBefore;
begin
	Set8087CW($133f);
end;

constructor TOggVorbisEncodeFunctions.Create;
begin
	if ( not FileExists( OGG_DLL_NAME ) )or( not FileExists( VORBIS_DLL_NAME ) )or( not FileExists( VORBISENC_DLL_NAME ) ) then
		raise Exception.Create( 'DLL ܂B' );

	FOGGDLLHandle := SafeLoadLibrary( OGG_DLL_NAME );
	FVORBISDLLHandle := SafeLoadLibrary( VORBIS_DLL_NAME );
	FVORBISENCDLLHandle := SafeLoadLibrary( VORBISENC_DLL_NAME );
	if ( FOGGDLLHandle = 0 )or( FVORBISDLLHandle = 0 )or( FVORBISENCDLLHandle = 0 ) then begin
		if FOGGDLLHandle <> 0 then FreeLibrary( FOGGDLLHandle );
		if FVORBISDLLHandle <> 0 then FreeLibrary( FVORBISDLLHandle );
		if FVORBISENCDLLHandle <> 0 then FreeLibrary( FVORBISENCDLLHandle );

		raise Exception.Create( 'DLL ̓ǂݍ݂Ɏs܂B' );
	end;

	inherited;

	Fvorbis_encode_init_vbr := GetProcAddress( FVORBISENCDLLHandle, 'vorbis_encode_init_vbr' );
	Fvorbis_info_init := GetProcAddress( FVORBISDLLHandle, 'vorbis_info_init' );
	Fvorbis_info_clear := GetProcAddress( FVORBISDLLHandle, 'vorbis_info_clear' );
	Fvorbis_dsp_clear := GetProcAddress( FVORBISDLLHandle, 'vorbis_dsp_clear' );
	Fvorbis_block_init := GetProcAddress( FVORBISDLLHandle, 'vorbis_block_init' );
	Fvorbis_block_clear := GetProcAddress( FVORBISDLLHandle, 'vorbis_block_clear' );
	Fvorbis_comment_init := GetProcAddress( FVORBISDLLHandle, 'vorbis_comment_init' );
	Fvorbis_comment_add := GetProcAddress( FVORBISDLLHandle, 'vorbis_comment_add' );
	Fvorbis_comment_add_tag := GetProcAddress( FVORBISDLLHandle, 'vorbis_comment_add_tag' );
	Fvorbis_comment_clear := GetProcAddress( FVORBISDLLHandle, 'vorbis_comment_clear' );
	Fvorbis_analysis_init := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis_init' );
	Fvorbis_analysis := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis' );
	Fvorbis_analysis_headerout := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis_headerout' );
	Fvorbis_analysis_buffer := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis_buffer' );
	Fvorbis_analysis_wrote := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis_wrote' );
	Fvorbis_analysis_blockout := GetProcAddress( FVORBISDLLHandle, 'vorbis_analysis_blockout' );
	Fvorbis_synthesis_headerin := GetProcAddress( FVORBISDLLHandle, 'vorbis_synthesis_headerin' );
	Fvorbis_bitrate_addblock := GetProcAddress( FVORBISDLLHandle, 'vorbis_bitrate_addblock' );
	Fvorbis_bitrate_flushpacket := GetProcAddress( FVORBISDLLHandle, 'vorbis_bitrate_flushpacket' );
	Fogg_stream_init := GetProcAddress( FOGGDLLHandle, 'ogg_stream_init' );
	Fogg_stream_packetin := GetProcAddress( FOGGDLLHandle, 'ogg_stream_packetin' );
	Fogg_stream_flush := GetProcAddress( FOGGDLLHandle, 'ogg_stream_flush' );
	Fogg_stream_pageout := GetProcAddress( FOGGDLLHandle, 'ogg_stream_pageout' );
	Fogg_page_eos := GetProcAddress( FOGGDLLHandle, 'ogg_page_eos' );
	Fogg_stream_clear := GetProcAddress( FOGGDLLHandle, 'ogg_stream_clear' );

end;

destructor TOggVorbisEncodeFunctions.Destroy;
begin
	if FOGGDLLHandle <> 0 then FreeLibrary( FOGGDLLHandle );
	if FVORBISDLLHandle <> 0 then FreeLibrary( FVORBISDLLHandle );
	if FVORBISENCDLLHandle <> 0 then FreeLibrary( FVORBISENCDLLHandle );

	inherited;
end;

function TOggVorbisEncodeFunctions.ogg_page_eos(const og: POggPage): Integer;
begin
	CallFuncBefore();
	Result := Fogg_page_eos( og );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.ogg_stream_clear(
  const os: POggStreamState): Integer;
begin
	CallFuncBefore();
	Result := Fogg_stream_clear( os );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.ogg_stream_flush(const os: POggStreamState; const og: POggPage): Integer;
begin
	CallFuncBefore();
	Result := Fogg_stream_flush( os, og );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.ogg_stream_init(const os: POggStreamState; const serialno: Integer): Integer;
begin
	CallFuncBefore();
	Result := Fogg_stream_init( os, serialno );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.ogg_stream_packetin(const os: POggStreamState; const op: POggPacket): Integer;
begin
	CallFuncBefore();
	Result := Fogg_stream_packetin( os, op );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.ogg_stream_pageout(const os: POggStreamState; const og: POggPage): Integer;
begin
	CallFuncBefore();
	Result := Fogg_stream_pageout( os, og );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis(const vb: PVorbisBlock; const op: POggPacket): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis( vb, op );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis_blockout(const v: PVorbisDSPState; const vb: PVorbisBlock): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis_blockout( v, vb );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis_buffer(
  const v: PVorbisDSPState; const vals: Integer): PPSingleArrayArray;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis_buffer( v, vals );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis_headerout(
  const v: PVorbisDSPState; const vc: PVorbisComment; const op, op_comm,
  op_code: POggPacket): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis_headerout( v, vc, op, op_comm, op_code );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis_init(
  const v: PVorbisDSPState; const vi: PVorbisInfo): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis_init( v, vi );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_analysis_wrote(
  const v: PVorbisDSPState; const vals: Integer): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_analysis_wrote( v, vals );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_bitrate_addblock(
  const vb: PVorbisBlock): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_bitrate_addblock( vb );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_bitrate_flushpacket(
  const v: PVorbisDSPState; const op: POggPacket): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_bitrate_flushpacket( v, op );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_block_clear(
  const vb: PVorbisBlock): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_block_clear( vb );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_block_init(
  const v: PVorbisDSPState; const vb: PVorbisBlock): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_block_init( v, vb );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_comment_add(
  const vc: PVorbisComment; const Comment: PChar);
begin
	CallFuncBefore();
	Fvorbis_comment_add( vc, Comment );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_comment_add_tag(
  const vc: PVorbisComment; const Tag, Contents: PChar);
begin
	CallFuncBefore();
	Fvorbis_comment_add_tag( vc, Tag, Contents );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_comment_clear(
  const vc: PVorbisComment);
begin
	CallFuncBefore();
	Fvorbis_comment_clear( vc );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_comment_init(
  const vc: PVorbisComment);
begin
	CallFuncBefore();
	Fvorbis_comment_init( vc );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_dsp_clear(
  const v: PVorbisDSPState);
begin
	CallFuncBefore();
	Fvorbis_dsp_clear( v );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_encode_init_vbr(
  const vi: PVorbisInfo; const Channels, Rate: Integer;
  const BaseQuality: Single): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_encode_init_vbr( vi, Channels, Rate, BaseQuality );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_info_clear(
  const vi: PVorbisInfo);
begin
	CallFuncBefore();
	Fvorbis_info_clear( vi );
	CallFuncAfter();
end;

procedure TOggVorbisEncodeFunctions.vorbis_info_init(
  const vi: PVorbisInfo);
begin
	CallFuncBefore();
	Fvorbis_info_init( vi );
	CallFuncAfter();
end;

function TOggVorbisEncodeFunctions.vorbis_synthesis_headerin(
  const vi: PVorbisInfo; const vc: PVorbisComment;
  const op: POggPacket): Integer;
begin
	CallFuncBefore();
	Result := Fvorbis_synthesis_headerin( vi, vc, op );
	CallFuncAfter();
end;

end.
