unit OggVorbisPacket;

interface

uses
	uChainList;

type
	//GR[hΏۂɂȂPCMf[^ƃGR[hOggpPbgǗ邽߂̃NX
	TOggVorbisEncoder_PacketData = class( TChainEntry )
	private
		FLength: Cardinal;
		FData: Pointer;
	public
		constructor Create( const Source: Pointer; const Length: Cardinal ); overload;
		constructor Create( const Header: Pointer; const HeaderLen: Cardinal; const Body: Pointer; const BodyLen: Cardinal ); overload;
		destructor Destroy(); override;
		property Data: Pointer read FData;
		property Length: Cardinal read FLength;
	end;

	TOggVorbisEncoder_PacketDataList = class( TChainList )
	private
		FTotalBufferSize: Int64;
	protected
		procedure EnteryAdded( const Item: TChainEntry ); override;
		procedure EnteryExtract( const Item: TChainEntry ); override;
	public
		property TotalBufferSize: Int64 read FTotalBufferSize;
	end;

implementation

{ TOggVorbisEncoder_PacketDataList }

procedure TOggVorbisEncoder_PacketDataList.EnteryAdded( const Item: TChainEntry );
var
	i: TOggVorbisEncoder_PacketData absolute Item;
begin
	Inc( FTotalBufferSize, i.FLength );
end;

procedure TOggVorbisEncoder_PacketDataList.EnteryExtract( const Item: TChainEntry );
var
	i: TOggVorbisEncoder_PacketData absolute Item;
begin
	Dec( FTotalBufferSize, i.FLength );
end;

{ TOggVorbisEncoder_PacketData }

constructor TOggVorbisEncoder_PacketData.Create(const Source: Pointer; const Length: Cardinal);
begin
	inherited Create();

	FLength := Length;
	GetMem( FData, FLength );
	Move( Source^, FData^, FLength );
end;

constructor TOggVorbisEncoder_PacketData.Create(const Header: Pointer; const HeaderLen: Cardinal; const Body: Pointer; const BodyLen: Cardinal);
var
	pb: PByte;
begin
	inherited Create();

	FLength := HeaderLen + BodyLen;
	GetMem( FData, FLength );
	if HeaderLen > 0 then
		Move( Header^, FData^, HeaderLen );
	if BodyLen > 0 then begin
		pb := FData;
		Inc( pb, HeaderLen );
		Move( Body^, pb^, BodyLen );
	end;
end;

destructor TOggVorbisEncoder_PacketData.Destroy;
begin
	FreeMem( FData );
	inherited;
end;

end.
