unit uMain2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Buttons, Menus, Dialogs, ExtCtrls, ComCtrls, StdCtrls,
  OggVorbisEncoder, DirectSound8Capture;

type
  TMain = class(TForm)
    StateUpdateTimer: TTimer;
    GroupBox1: TGroupBox;
    EncodingQuality: TTrackBar;
    StatusBar: TStatusBar;
    LvMeterPanelL: TPanel;
    LvMeterPanelR: TPanel;
    LvMeterL: TPaintBox;
    LvMeterR: TPaintBox;
    LvUpdate: TTimer;
    EncodingQualityLabel: TLabel;
    OggFilePath: TEdit;
    OggFilePathSideButton: TButton;
    OggFilePathLabel: TLabel;
    EncodingQualityValue: TLabel;
    SaveDialog: TSaveDialog;
    BeginRecording: TButton;
    EndRecording: TButton;
	procedure StateUpdateTimerTimer(Sender: TObject);
	procedure Idle1(Sender: TObject; var Done: Boolean);
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure EncodingQualityChange(Sender: TObject);
	procedure BeginRecordingClick(Sender: TObject);
	procedure EndRecordingClick(Sender: TObject);
	procedure ApplicationHint(Sender: TObject);
	procedure LvUpdateTimer(Sender: TObject);
	procedure LvMeterLPaint(Sender: TObject);
	procedure LvMeterRPaint(Sender: TObject);
    procedure OggFilePathSideButtonClick(Sender: TObject);
  private
	LvL, LvR: Single;
	dsc: TDirectSoundCapture;

	//FormCreateŏƃtH[ȂԂ̂ł
	procedure Initialize();
	{ Private 錾 }
  public
	enc: TOggVorbisEncoder;
	f: TFileStream;
	Capturing: Boolean;
	procedure DirectSoundCapture( const Sender: TObject; const Offset: Cardinal; BufferSize: Cardinal );
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

{ TForm1 }

procedure TMain.StateUpdateTimerTimer(Sender: TObject);
function BytesToStr1024( const Value: Int64; const InsertSpace: Boolean = True ): string;
const
	BYTE = 0;
	KILLO = 1024;
	MEGA = KILLO * 1024;
	GIGA = MEGA * 1024;
var
	TERA: Int64;
	s: String;
begin
	TERA := Int64(GIGA)*1024;
	if InsertSpace then s := ' ' else s := '';

	if Value < KILLO then
		Result := IntToStr(Value) + s + 'oCg'
	else if Value < MEGA then
		Result := FormatFloat( '#,##0.00',Value / KILLO ) + s + 'KB'
	else if Value < GIGA then
		Result := FormatFloat( '#,##0.00',Value / MEGA ) + s + 'MB'
	else if Value < TERA then
		Result := FormatFloat( '#,##0.00',Value / GIGA ) + s + 'GB'
	else
		Result := FormatFloat( '#,##0.00',Value / TERA ) + s + 'TB';
end;

//1000 oCgȂǂSɓBꍇ 0.XX KB ƕ\
function BytesToStr1000( const Value: Int64; const InsertSpace: Boolean = True ): string;
const
	BYTE = 0;
	KILLO = 1024;
	MEGA = KILLO * 1024;
	GIGA = MEGA * 1024;
const
	BYTE1000 = 0;
	KILLO1000 = 1000;
	MEGA1000 = KILLO1000 * 1000;
	GIGA1000 = MEGA1000 * 1000;
var
	TERA: Int64;
	TERA1000: Int64;
	s: String;
begin
	TERA := Int64(GIGA)*1024;
	TERA1000 := Int64(GIGA)*1000;
	if InsertSpace then s := ' ' else s := '';

	if Value < KILLO1000 then
		Result := IntToStr(Value) + s + 'oCg'
	else if Value < MEGA1000 then
		Result := FormatFloat( '#,##0.00',Value / KILLO ) + s + 'KB'
	else if Value < GIGA1000 then
		Result := FormatFloat( '#,##0.00',Value / MEGA ) + s + 'MB'
	else if Value < TERA1000 then
		Result := FormatFloat( '#,##0.00',Value / GIGA ) + s + 'GB'
	else
		Result := FormatFloat( '#,##0.00',Value / TERA ) + s + 'TB';
end;

//Explorerł̃t@CTCY\iTCY̐P̏ꍇ̂ݏ\j
function BytesToStr( const Value: Int64; const InsertSpace: Boolean = True ): string;
const
	BYTE = 0;
	KILLO = 1024;
	MEGA = KILLO * 1024;
	GIGA = MEGA * 1024;
const
	BYTE1000 = 0;
	KILLO1000 = 1000;
	MEGA1000 = KILLO1000 * 1000;
	GIGA1000 = MEGA1000 * 1000;
	Formats: array[Boolean] of string = ( '#,##0.00', '#,##');
var
	f: Extended;
	TERA: Int64;
	TERA1000: Int64;
	s, Ext: String;
begin
	TERA := Int64(GIGA)*1024;
	TERA1000 := Int64(GIGA)*1000;
	if InsertSpace then s := ' ' else s := '';

	if Value < KILLO1000 then begin
		//̏͗O
		Result := IntToStr(Value) + s + 'oCg';
		Exit;
	end else if Value < MEGA1000 then begin
		f := Value / KILLO;
		Ext := 'KB';
	end else if Value < GIGA1000 then begin
		f := Value / MEGA;
		Ext := 'MB';
	end else if Value < TERA1000 then begin
		f := Value / GIGA;
		Ext := 'GB';
	end else begin
		f := Value / TERA;
		Ext := 'TB';
	end;
	Result := FormatFloat( Formats[ f >= 10 ], f ) + s + Ext;
end;
begin
	if not Capturing then Exit;

	enc.WriteAllBodyAndFreeToStream( f );
	StatusBar.Panels[1].Text := BytesToStr1000( f.Size );
end;

procedure TMain.Idle1(Sender: TObject; var Done: Boolean);
begin
	Application.OnIdle := nil;
	Initialize();
end;

procedure TMain.Initialize;
begin
	Application.Hint := 'DirectSound ̏...';
	Application.ProcessMessages();
	dsc.Initialize();
	dsc.CreateCaptureBuffer( 44100, 16, 2, 2000, 5 );
	dsc.Start();

	LvUpdate.Enabled := True;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
	try
		enc := TOggVorbisEncoder.Create();

		dsc := TDirectSoundCapture.Create();
		dsc.NotifyThreadPriority := tpHigher;
		dsc.OnCaptured := DirectSoundCapture;

		Caption := Application.Title;
		Application.OnIdle := Idle1;
		Application.OnHint := ApplicationHint;

		Capturing := False;
	except
		on E: Exception do begin
			Application.MessageBox( PChar( E.Message+#13#10#13#10'AvP[VI܂B' ), nil, MB_ICONERROR );
			Application.Terminate();
			Application.ShowMainForm := False;
		end;
	end;
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
	if Capturing then EndRecordingClick( Self );

	if Assigned( dsc ) and Assigned( dsc.Buffer ) then dsc.Stop();

	LvUpdate.Enabled := True;

	if Assigned( dsc ) then enc.Free;
	if Assigned( dsc ) then dsc.Free;
end;

procedure TMain.EncodingQualityChange(Sender: TObject);
begin
	EncodingQualityValue.Caption := FormatFloat( '#,###0.000', EncodingQuality.Position/1000 )
end;

procedure TMain.BeginRecordingClick(Sender: TObject);
begin
	f := TFileStream.Create( OggFilePath.Text, fmCreate );

	enc.BeginEncode( 2, 44100, 16, EncodingQuality.Position/1000 );
	enc.WriteHeaderToStream( f );

	dsc.Stop();

	Capturing := True;
	dsc.Start();

	StateUpdateTimer.Enabled := True;

	GroupBox1.Enabled := False;
	OggFilePath.Enabled := False;
	OggFilePathLabel.Enabled := False;
	EncodingQuality.Enabled := False;
	EncodingQualityLabel.Enabled := False;
	EncodingQualityValue.Enabled := False;
	BeginRecording.Enabled := False;
	EndRecording.Enabled := True;
end;

procedure TMain.EndRecordingClick(Sender: TObject);
begin
	StateUpdateTimer.Enabled := False;

	Capturing := False;

	enc.EndEncode();
	enc.WriteAllBodyAndFreeToStream( f );

	f.Free;

	GroupBox1.Enabled := True;
	OggFilePath.Enabled := True;
	OggFilePathLabel.Enabled := True;
	EncodingQuality.Enabled := True;
	EncodingQualityLabel.Enabled := True;
	EncodingQualityValue.Enabled := True;
	BeginRecording.Enabled := True;
	EndRecording.Enabled := False;
end;

procedure TMain.ApplicationHint(Sender: TObject);
begin
	StatusBar.Panels[0].Text := GetLongHint(Application.Hint);
end;

procedure TMain.LvUpdateTimer(Sender: TObject);
var
	i, j: Integer;
	Lvs: array[0..5000] of Smallint;
	tL, tR: Integer;
	f: Single;
begin
	i := dsc.Position - Sizeof(Smallint)*5000;
	if i < 0 then Inc( i, dsc.BufferLength );
	dsc.BlockCopy( @Lvs[0], i, Sizeof(Smallint)*5000 );
	tL := 0;
	tR := 0;
	for i := 0 to 2500-1 do begin
		j := Abs( Lvs[i*2] );
		if j > tL then tL := j;
		j := Abs( Lvs[i*2+1] );
		if j > tR then tR := j;
	end;

	f := tL/32768.0;
	if f > LvL then LvL := f else LvL := LvL * 0.95;
	f := tR/32768.0;
	if f > LvR then LvR := f else LvR := LvR * 0.95;
	LvMeterLPaint( Self );
	LvMeterRPaint( Self );
end;

procedure TMain.LvMeterLPaint(Sender: TObject);
var
	h: Integer;
begin
	h := LvMeterL.Height-Trunc( LvMeterL.Height*LvL );
	with LvMeterL.Canvas do begin
		Brush.Color := clBtnFace;
		FillRect( Rect( 0, 0, LvMeterL.Width, h ) );
		Brush.Color := clLime;
		FillRect( Rect( 0, h, LvMeterL.Width, LvMeterL.Height ) );
	end;
end;

procedure TMain.LvMeterRPaint(Sender: TObject);
var
	h: Integer;
begin
	h := LvMeterR.Height-Trunc( LvMeterR.Height*LvR );
	with LvMeterR.Canvas do begin
		Brush.Color := clBtnFace;
		FillRect( Rect( 0, 0, LvMeterR.Width, h ) );
		Brush.Color := clLime;
		FillRect( Rect( 0, h, LvMeterR.Width, LvMeterR.Height ) );
	end;
end;

procedure TMain.DirectSoundCapture(const Sender: TObject;
  const Offset: Cardinal; BufferSize: Cardinal);
var
	Len1, Len2 :DWord;
	p1, p2: Pointer;
begin
	if not Capturing then Exit;

	dsc.Buffer.Lock( Offset, BufferSize, p1, @Len1, p2, @Len2, 0 );
	enc.AddPCM( p1, Len1, p2, Len2 );
	dsc.Buffer.Unlock( p1, Len1, p2, Len2 );
end;

procedure TMain.OggFilePathSideButtonClick(Sender: TObject);
begin
	SaveDialog.FileName := OggFilePath.Text;
	//SaveDialog͕ςȈʒuɃ_CAOo邩{͌Ȃ񂾂c
	if not SaveDialog.Execute() then Exit;
	OggFilePath.Text := SaveDialog.FileName;
end;

end.
